diff --git a/jerry-core/parser/js/js-scanner-util.c b/jerry-core/parser/js/js-scanner-util.c
index d73b152c73..d7486d4515 100644
--- a/jerry-core/parser/js/js-scanner-util.c
+++ b/jerry-core/parser/js/js-scanner-util.c
@@ -455,6 +455,17 @@ scanner_pop_literal_pool (parser_context_t *context_p, /**< context */
 {
   scanner_literal_pool_t *literal_pool_p = scanner_context_p->active_literal_pool_p;
   scanner_literal_pool_t *prev_literal_pool_p = literal_pool_p->prev_p;
+
+  if (literal_pool_p->source_p == NULL)
+  {
+    JERRY_ASSERT (literal_pool_p->status_flags & SCANNER_LITERAL_POOL_FUNCTION);
+    scanner_context_p->active_literal_pool_p = literal_pool_p->prev_p;
+
+    parser_list_free (&literal_pool_p->literal_pool);
+    scanner_free (literal_pool_p, sizeof (scanner_literal_pool_t));
+    return;
+  }
+
   parser_list_iterator_t literal_iterator;
   lexer_lit_location_t *literal_p;
   bool is_function = (literal_pool_p->status_flags & SCANNER_LITERAL_POOL_FUNCTION) != 0;
diff --git a/tests/jerry/es2015/regression-test-issue-3454.js b/tests/jerry/es2015/regression-test-issue-3454.js
new file mode 100644
index 0000000000..409a840ca4
--- /dev/null
+++ b/tests/jerry/es2015/regression-test-issue-3454.js
@@ -0,0 +1,21 @@
+// Copyright JS Foundation and other contributors, http://js.foundation
+//
+// Licensed under the Apache License, Version 2.0 (the "License");
+// you may not use this file except in compliance with the License.
+// You may obtain a copy of the License at
+//
+//     http://www.apache.org/licenses/LICENSE-2.0
+//
+// Unless required by applicable law or agreed to in writing, software
+// distributed under the License is distributed on an "AS IS" BASIS
+// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+// See the License for the specific language governing permissions and
+// limitations under the License.
+
+"use strict"
+try {
+  eval("var $ = function yield() {}");
+  assert(false);
+} catch (e) {
+  assert(e instanceof SyntaxError);
+}
